//+------------------------------------------------------------------+
//|                                        Bill Williams - Zones.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                     http://www.alpha-Traders.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, mikhail.eforex@yahoo.com"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Gray
#property indicator_color4 Gray
#property indicator_width1 2
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2

//----
extern color color1 = Red;
extern color color2 = Green;
extern color color3 = Gray;
extern color color4 = Gray;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM,0,2,Red);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,2,Green);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,2,Gray);
   SetIndexBuffer(2,ExtMapBuffer3);
      SetIndexStyle(3,DRAW_HISTOGRAM,0,2,Gray);
   SetIndexBuffer(3,ExtMapBuffer4);
//----
   string short_name="Bill Williams - Zones";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Red Zone");
   SetIndexLabel(1,"Green Zone");
   SetIndexLabel(2,"Gray Zone");
   SetIndexLabel(3,"Gray Zone");
   
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   SetIndexDrawBegin(2,10);
   SetIndexDrawBegin(3,10); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int  i,counted_bars=IndicatorCounted();
   double AOLast,AONow,ACLast,ACNow;    
//----
   if(Bars<=10) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=10;i++) 
      {
      ExtMapBuffer1[Bars-i]=0.0;
      ExtMapBuffer2[Bars-i]=0.0;
      ExtMapBuffer3[Bars-i]=0.0;
      ExtMapBuffer4[Bars-i]=0.0;
      
      }
//----
   if ( counted_bars > 0 )  int limit=Bars-counted_bars;
   if ( counted_bars ==0 )  limit=Bars-10-1; 
        
   for(i=limit;i>=0;i--) 
   {	 
   
   AOLast = iAO(Symbol(),0,i+1);
   AONow = iAO(Symbol(),0,i);       
   
   ACLast=iAC(Symbol(),0,i+1);
   ACNow=iAC(Symbol(),0,i);

   ExtMapBuffer1[i] =EMPTY;
   ExtMapBuffer2[i] =EMPTY;
   ExtMapBuffer3[i] =EMPTY;
   ExtMapBuffer4[i] =EMPTY;
   
   
   if (AONow > AOLast && ACNow > ACLast) 
   {ExtMapBuffer2[i] = High[i];ExtMapBuffer1[i] = Low[i] ;}
   
   else if (AONow < AOLast && ACNow < ACLast) 
   {ExtMapBuffer1[i] = High[i];ExtMapBuffer2[i] = Low[i] ;}
 
   else if (AONow < AOLast && ACNow > ACLast) 
   {ExtMapBuffer3[i] = High[i];ExtMapBuffer4[i] = Low[i] ;}

   else if (AONow > AOLast && ACNow < ACLast) 
   {ExtMapBuffer4[i] = High[i];ExtMapBuffer3[i] = Low[i] ;}
 
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+